Register Guidelines E-Books Search Today's Posts Mark Forums Read

Go Back   MobileRead Forums > E-Book Readers > Kobo Reader > Kobo Developer's Corner

Notices

Reply
 
Thread Tools Search this Thread
Old 01-20-2013, 05:32 PM   #1
j4GGy
Junior Member
j4GGy began at the beginning.
 
Posts: 6
Karma: 10
Join Date: Jan 2013
Location: Germany
Device: KoBo Glo
Problems compiling Qt for Kobo Glo

Hi guys,

I've been roaming this forum for the past 4-5 days and I really liked the idea of developing some own applications for my Kobo Glo. My ultimate goal would be to create a more comfortable pdf-reader but that is still far away :-)

I have next to none linux- and Qt-background except some playing around a few years ago and the last few days. I do however have some experience with C/C++. I run Ubuntu 12.04, installed Qt 4.8.0 (configured for ARM) and use arm-linux-guneabi-g++ for compiling. I can run standard C-executables compiled by me (like "hello world" and stuff) but as soon as I start using Qt I get stuck...

For example: If I download sergeyvl12's KoboLauncher (http://www.mobileread.com/forums/sho...d.php?t=201632) and use his binaries everything is fine and the application has no errors. But if I use his source files, compile them (qmake + make) and try to run them my Glo kind of freezes. In the telnet-console i get

Code:
Loading iType.. YES
but then nothing else happens. I suspect it has something to do with the differences showing up in what i get from the 'file' command:

KoboLauncher compiled by me:

Code:
file KoboLauncher
KoboLauncher: ELF 32-bit LSB executable, ARM, version 1 (SYSV), 
dynamically linked (uses shared libs), for GNU/Linux 2.6.31,
BuildID[sha1]=0xcd0375f0d4f08cb266fd2242ff86d41f8690d771, not stripped
sergeyvl12's binaries:

Code:
file KoboLauncher
KoboLauncher: ELF 32-bit LSB executable, ARM, version 1 (SYSV),
dynamically linked (uses shared libs), for GNU/Linux 2.6.16, not stripped
It would be really swell if someone could help me by telling me if my suspicions are right and how I have to reconfigure Qt/qmake or my compiler.

And always remember: linux-newb here, so if you have the time: I am in no way opposed to learn what BuildID[sha1] means

Last edited by j4GGy; 01-20-2013 at 05:34 PM.
j4GGy is offline   Reply With Quote
Old 01-21-2013, 01:11 AM   #2
sergeyvl12
ebook fan
sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.
 
Posts: 543
Karma: 2516376
Join Date: Dec 2010
Device: PocketBook 301+, Kindle 3 Wi-Fi, Onyx Boox A62, Kindle Touch
j4GGy

I used Qt 4.8.4 (the latest official qt without Kobo modifications).

My script for compiling Qt is:

#!/bin/sh

export PATH=$HOME/CodeSourcery/SourceryG++/bin:$PATH

make confclean

./configure -embedded arm -xplatform qws/linux-arm-g++ -opensource \
-prefix /usr/local/qt4_kobo -nomake examples -nomake demos \
-nomake docs -nomake translations -qt-libjpeg -no-stl -no-webkit \
-no-qt3support -no-phonon -no-phonon-backend -no-multimedia -no-openssl \
-no-javascript-jit -no-script -no-scripttools -no-opengl -no-gtkstyle -no-svg \
-no-gif -no-sql-sqlite -no-nis -no-cups -no-largefile \
-no-accessibility -no-xmlpatterns -no-audio-backend \
-no-declarative -no-libtiff -no-libmng -no-pch -no-dbus -no-declarative-debug \
-no-sql-db2 -no-sql-ibase -no-sql-mysql -no-sql-oci -no-sql-odbc -no-sql-psql -no-sql-sqlite \
-no-sql-sqlite2 -no-sql-sqlite_symbian \
-no-sql-tds -no-mmx -no-3dnow -no-sse -no-sse2 -no-accessibility \
-qt-gfx-linuxfb -qt-gfx-transformed -no-gfx-qvfb -no-gfx-vnc \
-no-gfx-multiscreen -no-gfx-directfb -no-gfx-qnx -no-gfx-integrityfb \
-no-kbd-qvfb -no-kbd-tty -no-kbd-linuxinput -no-kbd-qnx -no-kbd-integrity \
-no-mouse-qvfb -no-mouse-linuxtp -no-mouse-pc -no-mouse-tslib \
-DQT_KEYPAD_NAVIGATION -DQT_NO_QWS_CURSOR \
-confirm-license

make -j4

Try it.

P.S. What toolchain are you using for compiling ?

Last edited by sergeyvl12; 01-21-2013 at 01:28 AM.
sergeyvl12 is offline   Reply With Quote
Old 01-21-2013, 04:10 AM   #3
j4GGy
Junior Member
j4GGy began at the beginning.
 
Posts: 6
Karma: 10
Join Date: Jan 2013
Location: Germany
Device: KoBo Glo
Thx for the reply, it worked out for me. Although it proved me wrong The newly compiled files still have this Build[sha1]-thingy in the file-output. I guess it has to do with not using Codesourcery or whatever....

Regarding your question: I use arm-linux-gnueabi-* as compilers - I don't know if that counts as a "toolchain" but it works

I had to alter your script because of that, of course.
j4GGy is offline   Reply With Quote
Old 07-31-2013, 12:38 PM   #4
sunda
Member
sunda began at the beginning.
 
Posts: 15
Karma: 10
Join Date: Jul 2013
Device: Kobo
Quote:
Originally Posted by sergeyvl12 View Post
j4GGy

I used Qt 4.8.4 (the latest official qt without Kobo modifications).

My script for compiling Qt is:

#!/bin/sh

export PATH=$HOME/CodeSourcery/SourceryG++/bin:$PATH

make confclean

./configure -embedded arm -xplatform qws/linux-arm-g++ -opensource \
-prefix /usr/local/qt4_kobo -nomake examples -nomake demos \
-nomake docs -nomake translations -qt-libjpeg -no-stl -no-webkit \
-no-qt3support -no-phonon -no-phonon-backend -no-multimedia -no-openssl \
-no-javascript-jit -no-script -no-scripttools -no-opengl -no-gtkstyle -no-svg \
-no-gif -no-sql-sqlite -no-nis -no-cups -no-largefile \
-no-accessibility -no-xmlpatterns -no-audio-backend \
-no-declarative -no-libtiff -no-libmng -no-pch -no-dbus -no-declarative-debug \
-no-sql-db2 -no-sql-ibase -no-sql-mysql -no-sql-oci -no-sql-odbc -no-sql-psql -no-sql-sqlite \
-no-sql-sqlite2 -no-sql-sqlite_symbian \
-no-sql-tds -no-mmx -no-3dnow -no-sse -no-sse2 -no-accessibility \
-qt-gfx-linuxfb -qt-gfx-transformed -no-gfx-qvfb -no-gfx-vnc \
-no-gfx-multiscreen -no-gfx-directfb -no-gfx-qnx -no-gfx-integrityfb \
-no-kbd-qvfb -no-kbd-tty -no-kbd-linuxinput -no-kbd-qnx -no-kbd-integrity \
-no-mouse-qvfb -no-mouse-linuxtp -no-mouse-pc -no-mouse-tslib \
-DQT_KEYPAD_NAVIGATION -DQT_NO_QWS_CURSOR \
-confirm-license

make -j4

Try it.

P.S. What toolchain are you using for compiling ?

Hi sergeyvl12,
can you please give a step by step to make this Qt enviroment to compile?
(what is meant by "make confclean" and make "-j4")

I have Ubuntu and Codesourcery in the default libraray installed, but somehow not able to setup Qt development like here
sunda is offline   Reply With Quote
Old 08-01-2013, 05:01 PM   #5
sergeyvl12
ebook fan
sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.
 
Posts: 543
Karma: 2516376
Join Date: Dec 2010
Device: PocketBook 301+, Kindle 3 Wi-Fi, Onyx Boox A62, Kindle Touch
Quote:
Originally Posted by sunda View Post
Hi sergeyvl12,
can you please give a step by step to make this Qt enviroment to compile?
(what is meant by "make confclean" and make "-j4")

I have Ubuntu and Codesourcery in the default libraray installed, but somehow not able to setup Qt development like here
sunda

1. First of all, you need a new toolchain: https://github.com/kobolabs/Kobo-Rea..._linux.tar.bz2
if you want to develop for the 2.6.1+ firmware. So, install this toolchain first
2. Tomorrow I'll share my Qt build (libs and headers). So, you don't need to build Qt.

That's all.
sergeyvl12 is offline   Reply With Quote
Old 08-02-2013, 08:03 AM   #6
stefjan
Junior Member
stefjan is on a distinguished road
 
Posts: 6
Karma: 57
Join Date: Jun 2013
Device: kobo glo
Hi sergeyvl12

Just for my own understanding: in your reply to j4GGy you mention that your script contains this:

export PATH=$HOME/CodeSourcery/SourceryG++/bin:$PATH

which looks like the path to the "old" toolchain, so are you doing your development with that one?

thanks
stefjan
stefjan is offline   Reply With Quote
Old 08-03-2013, 09:25 AM   #7
sergeyvl12
ebook fan
sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.sergeyvl12 ought to be getting tired of karma fortunes by now.
 
Posts: 543
Karma: 2516376
Join Date: Dec 2010
Device: PocketBook 301+, Kindle 3 Wi-Fi, Onyx Boox A62, Kindle Touch
Quote:
Originally Posted by stefjan View Post
Hi sergeyvl12

Just for my own understanding: in your reply to j4GGy you mention that your script contains this:

export PATH=$HOME/CodeSourcery/SourceryG++/bin:$PATH

which looks like the path to the "old" toolchain, so are you doing your development with that one?

thanks
stefjan
No, I've switched to the new toolchain. The new script for Qt build now looks like:

Code:
#!/bin/sh

export PATH=/opt/gcc-linaro-kobo/bin:$PATH

make confclean

./configure -embedded arm -xplatform qws/linux-arm-gnueabihf-g++ -opensource -prefix /usr/local/qt4_kobo_new -nomake examples -nomake demos \
-nomake docs -nomake translations -qt-libjpeg -no-stl -no-webkit -no-qt3support -no-phonon -no-phonon-backend -no-multimedia -no-openssl \
-no-javascript-jit -no-script -no-scripttools -no-opengl -no-gtkstyle -no-svg -no-gif -no-sql-sqlite -no-nis -no-cups -no-largefile \
-no-accessibility -no-xmlpatterns -no-audio-backend -no-declarative -no-libtiff -no-libmng -no-pch -no-dbus -no-declarative-debug \
-no-sql-db2 -no-sql-ibase -no-sql-mysql -no-sql-oci -no-sql-odbc -no-sql-psql -no-sql-sqlite -no-sql-sqlite2 -no-sql-sqlite_symbian \
-no-sql-tds -no-mmx -no-3dnow -no-sse -no-sse2 -no-accessibility \
-qt-gfx-linuxfb -qt-gfx-transformed -no-gfx-qvfb -no-gfx-vnc -no-gfx-multiscreen -no-gfx-directfb -no-gfx-qnx -no-gfx-integrityfb \
-no-kbd-qvfb -no-kbd-tty -no-kbd-linuxinput -no-kbd-qnx -no-kbd-integrity \
-no-mouse-qvfb -no-mouse-linuxtp -no-mouse-pc -no-mouse-tslib \
-DQT_KEYPAD_NAVIGATION -DQT_NO_QWS_CURSOR \
-confirm-license

make -j4

xclock
I've shared my own Qt build + new toolchain here:

http://www.mobileread.com/forums/sho...67&postcount=1
sergeyvl12 is offline   Reply With Quote
Reply

Thread Tools Search this Thread
Search this Thread:

Advanced Search

Forum Jump

Similar Threads
Thread Thread Starter Forum Replies Last Post
Glo Can kobo glo run android app such as nook glo? suspect Kobo Developer's Corner 1 12-28-2012 11:25 PM
Kobo glo 3.2.1: PDF problems unsolved by Kobo Hotbill Kobo Reader 0 12-28-2012 05:31 AM
Problems compiling calibre DOMBlogger Development 2 01-23-2012 04:48 AM
Problems compiling unkilbeeg Sigil 1 09-13-2009 01:49 PM
Problems compiling eb1150 on Ubuntu Intrepid luqmaninbmore Fictionwise eBookwise 10 01-15-2009 07:14 PM


All times are GMT -4. The time now is 07:10 AM.


MobileRead.com is a privately owned, operated and funded community.